/*****************************************************************************\
                          A_Format.C  -  description
                             -------------------
    begin                : Tue Jan 29 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "A_Format.h"

A_Format::A_Format()
{
    sample_rate      = 44100;
    channels         = 2;
    bits             = 16;
    samples_per_pack = 1;
    bits_per_second  = sample_rate * channels * bits;
}


A_Format::A_Format( const A_Format &format )
{
    sample_rate      = format.sample_rate;
    channels         = format.channels;
    bits             = format.bits;
    samples_per_pack = format.samples_per_pack;
    bits_per_second  = format.bits_per_second;
}


A_Format::A_Format( int Sample_rate, int Channels )
{
    sample_rate      = Sample_rate;
    channels         = Channels;
    bits             = 16;
    samples_per_pack = 1;
    bits_per_second  = sample_rate * channels * bits;
}


A_Format::~A_Format()
{
}


/*
A_Format &A_Format::operator =(A_Format format)
{
    SetAFormat( format );
    return *this;
}
*/

void A_Format::SetAFormat( A_Format &format )
{
    sample_rate      = format.sample_rate;
    channels         = format.channels;
    bits             = format.bits;
    samples_per_pack = format.samples_per_pack;
    bits_per_second  = format.bits_per_second;
}
