/*****************************************************************************\
                          codecinfo_entry.C  -  description
                             -------------------
    begin                : Fri Jan 18 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "Codec_Info.h"

Codec_Info::Codec_Info( const String Dateityp, const String Codecname, V_Codec *(*konstruktor)(V_Track *), const String Codecalias, const String InfoTxt, bool read, bool write )
{
    datei_typ = Dateityp;
    codec_name = Codecname;

    if( Codecalias != "" )
        alias_name = Codecalias;
    else
        alias_name = Codecname;

    v_konstr = konstruktor;
    a_konstr = NULL;

    info_txt = InfoTxt;
    can_read = read;
    can_write = write;
}




Codec_Info::Codec_Info( const String Dateityp, const String Codecname, A_Codec *(*konstruktor)(A_Track *), const String Codecalias, const String InfoTxt, bool read, bool write )
{
    datei_typ = Dateityp;
    codec_name = Codecname;

    if( Codecalias != "" )
        alias_name = Codecalias;
    else
        alias_name = Codecname;
    
    v_konstr = NULL;
    a_konstr = konstruktor;

    info_txt = InfoTxt;
    can_read = read;
    can_write = write;
}




Codec_Info::Codec_Info( const Codec_Info &entry )
{
    datei_typ = entry.datei_typ;
    codec_name = entry.codec_name;
    alias_name = entry.alias_name;
    v_konstr = entry.v_konstr;
    a_konstr = entry.a_konstr;

    info_txt = entry.info_txt;
    can_read = entry.can_read;
    can_write = entry.can_write;
}




Codec_Info::Codec_Info( )
{
    v_konstr = NULL;
    a_konstr = NULL;
}



Codec_Info::~Codec_Info()
{

}



/** Echter Name des Codecs
  */
String Codec_Info::CodecName( void )
{
    return codec_name;
}



/** Alias Name des Codecs
  */
String Codec_Info::AliasName( void )
{
    return alias_name;
}



/**Video Codec erstellen
  */
V_Codec *Codec_Info::CreateVCodec( V_Track *track )
{
    if( v_konstr != NULL )
        return v_konstr( track );

    return NULL;
}




/**Audio Codec erstellen
  */
A_Codec *Codec_Info::CreateACodec( A_Track *track )
{
    if( a_konstr != NULL )
        return a_konstr( track );

    return NULL;
}

