#ifndef _CONVERT_H_
#define _CONVERT_H_

#include "cmodels.h"

#define TABLE_SIZE      (8*256)
#define CONVERT_COLORS 7
#define ADD(symbol) &Convert::convert_ ## symbol


class Convert {
public:
    Convert( int infmt, int outfmt, int width, int height );
    ~Convert();

    void do_convert( unsigned char *inbuf, unsigned char *outbuf );

protected:
    typedef void (Convert::*convert_func)(void);
    typedef void (Convert::*convert_init_func)(int);

    /************ Prototypes ************/
    void convert_init24(int in);
    void convert_nil24(void);
    void convert_24to8(void);
    void convert_24to16(void);
    void convert_24to422(void);
    void convert_24to420(void);
    void convert_24toG(void);
    void convert_init8(int in);
    void convert_nil8(void);
    void convert_8to24(void);
    void convert_8to16(void);
    void convert_8to422(void);
    void convert_8to420(void);
    void convert_8toG(void);
    void convert_init16(int in);
    void convert_nil16(void);
    void convert_16to24(void);
    void convert_16to8(void);
    void convert_16to422(void);
    void convert_16to420(void);
    void convert_16toG(void);
    void convert_init422(int in);
    void convert_nil422(void);
    void convert_422to24(void);
    void convert_422to8(void);
    void convert_422to16(void);
    void convert_422to420(void);
    void convert_422toG(void);
    void convert_init420(int in);
    void convert_nil420(void);
    void convert_420to24(void);
    void convert_420to8(void);
    void convert_420to16(void);
    void convert_420to422(void);
    void convert_420toG(void);
    void convert_initG(int in);
    void convert_nilG(void);
    void convert_Gto24(void);
    void convert_Gto16(void);
    void convert_Gto422(void);
    void convert_Gto420(void);
    void convert_Gto8(void);
    void convert_nil(void);

    /***** Variablen *****/
    int inwidth ;
    int inheight;
    int outwidth;
    int outheight;
    int informat, outformat;
    int in_pal;
    int out_pal;
    int in_altcol;
    int out_altcol;
    int convert_bytes;

    unsigned char *convert_outbuf, *convert_inbuf;

    int convert_5to8tab[32];
    int convert_6to8tab[64];
    int convert_8to5tab[256];
    int convert_8to6tab[256];
    int convert_256to5tab[256];
    int convert_256to9tab[256];
    int convert_32to5tab[32];
    int convert_64to9tab[64];
    int convert_palette[256][3];
    int convert_palette16[256][3];
    int convert_paletteYCC[256][3];
    int convert_paletteG[256];
    int convert_backpal[5][9][5];

    int convert_rgb_ycc_tab[TABLE_SIZE];
    int convert_Crrtab[256];
    int convert_Cbbtab[256];
    int convert_Crgtab[256];
    int convert_Cbgtab[256];
    unsigned char convert_range[5*256+128];
    unsigned char *convert_rangetable;

    convert_func convert_doit;

    static const int convert_color_bpps[CONVERT_COLORS];

    static const convert_init_func convert_inittable[CONVERT_COLORS];

    static const convert_func convert_table[CONVERT_COLORS][CONVERT_COLORS];

};

#endif
