/*****************************************************************************\
                          Errors.C  -  description
                             -------------------
    begin                : Son Nov 17 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "Errors.h"
#include "translate.h"

Errors::Errors()
{
    err_type = NoError;
}


Errors::Errors( Error_Type type )
{
    err_type = NoError;

    *this = type;
}


Errors::~Errors()
{
}



Errors &Errors::operator = ( Error_Type type )
{
    err_type = type;
    
    return *this;
}


const char* Errors::ErrorText() {

    // Fehlermeldung setzen
    switch( err_type ) {
    case NoError:
        return ""; break;
    case FileType:
        return _("File type not supported by modul!"); break;
    case IO_Mode:
        return _("Io mode not supported by modul!"); break;
    case Open:
        return _("File could not be opened!"); break;
    case Read:
        return _("Error reading from file!"); break;
    case Write:
        return _("Error writing to file!"); break;
    case Unkown:
    default:
        return _("Unknown error!"); break;
    }
    
    return "";
}



bool Errors::operator == ( Error_Type type )
{
    return err_type == type;
}


bool Errors::operator != ( Error_Type type )
{
    return err_type != type;
}
