/***************************************************************************
                          Errors.h  -  description
                             -------------------
    begin                : Son Nov 17 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ERRORS_H
#define ERRORS_H

#include "String.h"


/**Fehler-Behandlung in libVideoFile
  *@author Christian Tusche
  */

class Errors {
public:
    typedef enum{ NoError, FileType, IO_Mode, Open, Read, Write, Unkown } Error_Type;
    
    Errors();
    Errors( Error_Type type );
    
    ~Errors();    

    Errors &operator = ( Error_Type type );
    bool operator == ( Error_Type type );
    bool operator != ( Error_Type type );

    /**liefert eine passende Fehlermeldung
      */
    const char* ErrorText();
    
private:
    Error_Type err_type;
};

#endif
