/*****************************************************************************\
                          iomodulinfo.cpp  -  description
                             -------------------
    begin                : Wed Jan 16 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "IOModul_Info.h"

IOModul_Info::IOModul_Info( const String Dateityp, VideoFile *(*konstruktor)(const String, VideoFile::IO_Mode), const String InfoTxt )
{
    datei_typ = Dateityp;
    konstr = konstruktor;

    info_txt = InfoTxt;
}



IOModul_Info::IOModul_Info( const IOModul_Info &info )
{
    datei_typ = info.datei_typ;
    konstr = info.konstr;

    info_txt = info.info_txt;
}



IOModul_Info::IOModul_Info()
{
    konstr = NULL;
}



IOModul_Info::~IOModul_Info()
{
}








/**Video Codec erstellen
  */
VideoFile *IOModul_Info::CreateModul( const String file, VideoFile::IO_Mode mode )
{
    if( konstr != NULL ) {
        return  konstr( file, mode );
    }

    return NULL;
}
