/***************************************************************************
                          iomodulinfo.h  -  description
                             -------------------
    begin                : Wed Jan 16 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _IOMODUL_INFO_H
#define _IOMODUL_INFO_H

#include "String.h"
#include <vector>
using std::vector;

#include "VideoFile.h"
#include "PluginInfo.h"

class IOModulPlugins;


/**Informationen zu einem IO-Modul
  *@author Christian Tusche
  */


class IOModul_Info: public PluginInfo {
    friend class IOModulPlugins;
public:
    IOModul_Info( const String Dateityp, VideoFile *(*konstruktor)(const String, VideoFile::IO_Mode), const String InfoTxt = "" );
    IOModul_Info( const IOModul_Info &info );
    IOModul_Info();
    ~IOModul_Info();

    /**IO-Modul erstellen
      */
    VideoFile *CreateModul( const String file, VideoFile::IO_Mode mode );

    /**Dateityp
      */
    String FileTyp( void ) { return datei_typ; }

    /**Beschreibung des Moduls
      */
    String InfoText( void ) { return info_txt; }

protected:
    String datei_typ;
    VideoFile *(*konstr)(const String, VideoFile::IO_Mode);
    String info_txt;
};

#endif
