/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include <stdio.h>

#include "VideoFile.h"
#include "Track.h"
#include "debug.h"
#include "translate.h"




/***** Konstruktor / Destruktor *****/
Track::Track( VideoFile *File, int track, const String Codec_name )
{
    // Variablen initialisieren
    file = File;
    nummer = track;
    pos = 0;
    bytes = 0;
    codec_name = Codec_name;
    codec_id = Codec_name;
    iomode = file->iomode;
    block_rate = 25.0;
    total_blocks = 0;

    AV_Codecs = file->AV_Codecs;
}





Track::~Track()
{
    DEBUG_TXT( _("close track %s"), codec_name.chars() );
}


int Track::Seek( long block )
{
    ERROR_TXT( _("Seek not implemented!") );
    return 0;
}
