/********************************************************************\
*****   Basisklasse fr Video-Codec                              *****
\********************************************************************/

#ifndef _VIDEO_CODEC_H_
#define _VIDEO_CODEC_H_

#include <sys/types.h>
#include "Convert.h"
#include "Codec.h"
#include "V_Format.h"
#include "VideoFrame.h"

//class VideoFile;
class V_Track;

/**Basisklasse fr Video Codecs.<br>
  *@author Christian Tusche
  */

class V_Codec: public Codec, public V_Format {
public:
    V_Codec( V_Track *Track );

    virtual ~V_Codec();

    /**Farbraum festlegen
      */
    virtual bool ColorModel( int cmodel );

    /**Video-Bild schreiben
      *Rckgabewert 1   -   OK
      *             0   -   Fehler
      */
    virtual int encodeVideo( VideoFrame *bild );

    /**Video-Bild lesen
      *Rckgabewert 1   -   OK
      *             0   -   Fehler
      */
    virtual int decodeVideo( VideoFrame *bild );

    /**Video positionieren
      */
    virtual int SeekFrame( long bild );

    /**Bild-Position setzen
      */
    virtual int SeekTime( double seconds );

    /**beim Encoden das letzte Bild nochmal schreiben<br>
      *Der Codec kann dann ausgehend von den letzten Daten das
      *gleiche Bild nochmal schreiben. Das ist meist effizienter als
      *ein encode() Aufruf mit den gleichen Bilddaten.
      */
    virtual int CopyFrame( void );

    /**leifert Zeiger auf Track
      */
    V_Track *Track( void ) { return track; }

protected:
    V_Track *track;        // Videotrack

    /**Video-Bild schreiben<br>
      *interne Implementierung
      */
    virtual int encode( VideoFrame *bild );

    /**Video-Bild lesen<br>
      *interne Implementierung
      */
    virtual int decode( VideoFrame *bild );

    /**internes Farbformat<br>
      *wird im Codec aufgerufen, um automatische Farbraumkonvertierung
      *in/von diesem Format zu aktivieren<br>
      *mu nach "V_Codec::ColorModel( cmodel )" aufgerufen werden.
      */
    virtual bool ColorModel_intern( int cmodel );

    int color_model;        // Farbraum fr Videodaten
    int color_model_intern; // Farbraum fr internen Codec

    //Convert *enc_converter;  // konvertiert Farbraum bei encode
    //Convert *dec_converter;  // konvertiert Farbraum bei decode

    //uint8_t *frame_puffer;    // Puffer fr ein gelesenes Bild
    //size_t frame_puffer_gr;  // Gre des Puffers

    VideoFrame *enc_frame_puffer;    // Puffer fr ein geschriebenes Bild
};

#endif
