/***************************************************************************
                          codecplugins.h  -  description
                             -------------------
    begin                : Sun Jan 6 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CODECPLUGINS_H
#define CODECPLUGINS_H

#include "pluginloader.h"
#include "PluginList.h"
#include "Codec_Info.h"

class V_Codec;
class A_Codec;
class V_Track;
class A_Track;
class Track;


/**Plugins fr Audio- und Video-Codecs
  *@author Christian Tusche
  */

class CodecPlugins : public PluginLoader  {
public: 
    CodecPlugins();
    ~CodecPlugins();

    /**Video Codec erstellen
      */
    V_Codec *CreateVCodec( V_Track *track, const String Dateityp, const String &Codecname );

    /**Audio Codec erstellen
      */
    A_Codec *CreateACodec( A_Track *track, const String Dateityp, const String &Codecname );

    /**Infoeintrag finden
      */
    Codec_Info *FindCodec( Track *track, const String &Dateityp, const String &Codecname );

    /**Liste mit Codecs
      */
    PluginList<Codec_Info> *AV_Codecs( void ) { return &reg_codecs; }

protected:
    int RegisterModul( modul_data *data );

private:
    PluginList<Codec_Info> reg_codecs;
};

#endif
