/*****************************************************************************\
                          iomodulplugins.cpp  -  description
                             -------------------
    begin                : Wed Jan 16 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "config.h"
#include "iomodulplugins.h"
#include "debug.h"
#include "translate.h"
#include <assert.h>

IOModulPlugins::IOModulPlugins()
:PluginLoader()
{
    // Plugins laden
    AddDir( PREFIX"/lib/VideoFile/iomodule" );
}



IOModulPlugins::~IOModulPlugins()
{
}





VideoFile *IOModulPlugins::CreateModul( const String file, const String Dateityp, VideoFile::IO_Mode mode )
{
    INFO_TXT( _("Create io-module for filetype \"%s\""), Dateityp.chars() );

    IOModul_Info *gefunden = FindModul( Dateityp );
    
    if( gefunden != NULL ) {
        return gefunden->CreateModul( file, mode );
    }
    
    return NULL;
}






int IOModulPlugins::RegisterModul( modul_data *data )
{
    if( data->Typ != "VideoFile" ) {
        return 0;
    }

    // Liste der Dateiformate des Moduls zu Liste der
    // unterstzten Formate hinzufgen
    PluginList<IOModul_Info> *liste;
    liste = (PluginList<IOModul_Info> *)data->ModulInfo();

    // Dateinamen des Moduls speichern
    reg_moduls.Libname( data->Name.chars() );
    reg_moduls += *liste;

    return 1;
}







IOModul_Info *IOModulPlugins::FindModul( const String Dateityp )
{
    IOModul_Info *format;

    assert( Dateityp != "" );

    for( unsigned int i=0; i < reg_moduls.NumElements(); i++ ) {
        format = &reg_moduls.Element(i);
        if( format->datei_typ == Dateityp ) {
            return format;
        }
    }

    return NULL;
}
