/*****************************************************************************\
                          optionentry.C  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


#include <stdlib.h>
#include <stdio.h>

#include "optionentry.h"
#include "optionlist.h"



OptionEntry::OptionEntry( OptionList *l, const String name, const String info )
{
    opt_name = name;
    info_txt = info;
    list = l;
    set_option = false;
}




OptionEntry::~OptionEntry()
{
}




const String &OptionEntry::Name(void)
{
    return opt_name;
}




const String &OptionEntry::Info(void)
{
    return info_txt;
}



OptionEntry& OptionEntry::operator = ( const String &wert )
{
    opt_arg = wert;
    SetOption();
    return *this;
}



OptionEntry& OptionEntry::operator = ( const char *wert )
{
    opt_arg = wert;
    SetOption();
    return *this;
}



OptionEntry& OptionEntry::operator = ( int wert )
{
    char tmp[50];

    sprintf( tmp, "%i", wert );
    opt_arg = tmp;
    SetOption();
    return *this;
}



OptionEntry& OptionEntry::operator = ( double wert )
{
    char tmp[50];

    sprintf( tmp, "%.15f", wert );
    opt_arg = tmp;
    SetOption();
    return *this;
}





OptionEntry::operator String&()
{
    return opt_arg;
}



OptionEntry::operator const char*()
{
    return opt_arg.chars();
}



OptionEntry::operator int()
{
    return strtol( opt_arg.chars(), NULL, 0 );
}




OptionEntry::operator double()
{
    return strtod( opt_arg.chars(), NULL );
}








int OptionEntry::SetOption( void )
{
    // nderung bernehmen
    if( !set_option && list != NULL && opt_name != "" ) {
        set_option = true;
        int stat = list->SetOption( this );
        set_option = false;
        return stat;
    }

    return 0;
}
