/***************************************************************************
                          optionentry.h  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIONENTRY_H
#define OPTIONENTRY_H

#include "String.h"

class OptionList;

/**Eine Option
  *@author Christian Tusche
  */

class OptionEntry {
    friend class OptionList;

public:
    OptionEntry( OptionList *l, const String name, const String info = "" );
    ~OptionEntry();

    /**Name des Eintrags
      */
    const String &Name(void);

    /**Beschreibung des Eintrags
      */
    const String &Info(void);

    OptionEntry& operator = ( const String &wert );
    OptionEntry& operator = ( const char *wert );
    OptionEntry& operator = ( int wert );
    OptionEntry& operator = ( double wert );

    operator String&();
    operator const char*();
    operator int();
    operator double();

protected:
    int SetOption( void );

    // Name der Option
    String opt_name;

    // Das Argument als Text-String formatiert
    String opt_arg;

    // Beschreibung der Option fr den User
    String info_txt;

    // bergeordnete Listenklasse
    OptionList *list;

    // Aufruf von SetOption() luft
    bool set_option;
};

#endif
