/*****************************************************************************\
                          optionlist.C  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
\*****************************************************************************/

/*****************************************************************************\
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/

#include "optionlist.h"

OptionList::OptionList()
{
    // erzeuge "Null-Option" fr alle nichtvorhandenen Eintrge
    push_back( new OptionEntry( NULL, "", "" ) );
}




OptionList::~OptionList()
{
    // Liste vernichten
    while( size() > 0 ) {
        delete back();
        pop_back();
    }

}




/**Option "optname" in Liste finden
  */
OptionEntry &OptionList::Option( const String optname )
{
    int i = 0;
    OptionEntry *opt = &Option( i );

    while( opt->Name() != "" && opt->Name() != optname ) {
        opt = &Option( ++i );
    }

    return *opt;
}








/**liefert Option n
  */
OptionEntry &OptionList::Option( unsigned int n )
{
    if( (size() - 1) <= n ) {
        return *front();
    }

    return **( begin() + ( n + 1 ) );
}






/**Anzahl der Eintrge in der Liste
  */
unsigned int OptionList::NumOptions( void )
{
    return size() - 1;
}





/**Option zu Liste hinzufgen
  */
OptionEntry &OptionList::AddOption( const String optname, const String info )
{
    OptionEntry *opt = new OptionEntry( this, optname, info );

    push_back( opt );

    return *opt;
}





/**Wird aufgerufen, wenn die Option opt verndert wurde.
  */
int OptionList::SetOption( OptionEntry *opt )
{
    return 0;
}
