/***************************************************************************
                          optionlist.h  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIONLIST_H
#define OPTIONLIST_H

#include <vector>
using std::vector;

#include "String.h"

#include "optionentry.h"


/**Liste mit den Optionen eines Codecs
  *@author Christian Tusche
  */

class OptionList : private vector<OptionEntry *>  {
    friend class OptionEntry;
public: 
    OptionList();
    virtual ~OptionList();

    /**Option "optname" in Liste finden
      */
    OptionEntry &Option( const String optname );

    /**liefert Option n
      */
    OptionEntry &Option( unsigned int n );

    /**Anzahl der Eintrge in der Liste
      */
    unsigned int NumOptions( void );

protected:
    /**Option zu Liste hinzufgen
      */
    OptionEntry &AddOption( const String optname, const String info = "" );

    /**Wird aufgerufen, wenn die Option opt verndert wurde.
      */
    virtual int SetOption( OptionEntry *opt );
};

#endif
