/***************************************************************************
                          ausgabedatei.h  -  description
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AUSGABEDATEI_H
#define AUSGABEDATEI_H

#include "VideoFile/VideoFile.h"
#include "io_datei.h"
#include "eingabedatei.h"

/**Behandelt die Ausgabe in eine Videodatei
  *@author Christian Tusche
  */

class AusgabeDatei: public IO_Datei {
public: 
    AusgabeDatei();
    ~AusgabeDatei();


    /**Ausgabe ffen <br>
      *alle Parameter (Framerate, Gre, ...) werden von Eingabedatei bernommen
      */
    int open( EingabeDatei *Eingabe, int breite=0, int hoehe=0, int a_channels=0 );

    /**Ausgabe ffen <br>
      *Parameter werden explizit angegeben
      */
    int open( double rate, int breite, int hoehe,
              int sound_rate, int sound_channels );

    /**Datei schlieen
      */
    void close( void );

    /**Liefert den Namen fr die nchste Datei<br>
      *Wenn ein %n im Namen enthalten ist, wird diese durch
      *die laufende Nummer 0,1,2,... ersetzt, ansonsten wird
      *eine Nummer an die Datei angehngt
      */
    const String getNextName( void );

    /**liefert Namen der aktuellen Datei
      */
    const char *getName( void );

    /** Video Frame schreiben
      */
    int encodeVideo( VideoFrame *bild );

    /** Video Rohdaten schreiben
      */
    int writeVideoData( unsigned char *data, long bytes, int keyframe=0 );

    /** Audio schreiben
      */
    int encodeAudio( int16_t **puffer, int samples );

    /** Farbraum fr Videoeingabe einstellen
      */
    bool ColorModel( int cmodel );

    /**Bisher geschriebene Bytes
      */
    long long BytesWritten( void );
    
    /**Video Track
      */
    V_Codec *Video(void) { return V_Aus; }
    
    /**Audio Track
      */
    A_Codec *Audio(void) { return A_Aus; }
    

    bool video;
    bool audio;

protected:
    int nummer;
    String neuer_Name;

    VideoFile *AV_Ausgabe;
    V_Codec *V_Aus;
    A_Codec *A_Aus;
};

#endif
