/***************************************************************************
                          io_datei.h  -  description
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IO_DATEI_H
#define IO_DATEI_H

#include "VideoFile/String.h"

#include "codec_optionen.h"


/**Verwaltet Dateinamen und zugehrige Dateiformate
  *@author Christian Tusche
  */

class IO_Datei {
public:
    IO_Datei();
    ~IO_Datei();

    /** Komandozeilenparameter parsen
      */
    void parseArg( const char *arg );

    /** Komandozeilenparameter parsen
      */
    void parseArg_Video( const char *arg );

    /** Komandozeilenparameter parsen
      */
    void parseArg_Audio( const char *arg );

    /**aktueller Dateiname der Videodatei
      */
    const char *getName_Video( void );

    /**aktueller Dateiname der Audiodatei
      */
    const char *getName_Audio( void );

    /**Zeit-Differenz
      */
    double Seconds( void );

    /**Startzeit der Vidoe-Datei
      */
    double Start_Video( void ) { return v_start; }

    /**Startzeit der Audio-Datei
      */
    double Start_Audio( void ) { return a_start; }

    /**setze Codec fr Audioausgabe
      */
    void SetACodec( Codec_Optionen *opt );

    /**setze Codec fr Videoausgabe
      */
    void SetVCodec( Codec_Optionen *opt );

protected:
    void parseArg( const char *arg, String &name, String &format, double &start, double &ende, double &offset );

    String v_name, a_name;
    String v_format, a_format;

    double a_start, a_ende, v_start, v_ende;

    Codec_Optionen *vcodec, *acodec;
};

#endif
