/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/



#include <stdio.h>
#include <assert.h>

#include "Audio_th.h"
#include "debug.h"



/****************************************************************************************/
/***** Konstruktor / Destruktor *********************************************************/
/****************************************************************************************/
Audio_th::Audio_th( void )
{

    // Optionen
    Rate( 44100 );
    Bits( 16 );
    Channels( 2 );

    // Pufferverwaltung
    fifo = NULL;
    EQNULL( (void *)sem_init( &fifo_bereit,0,0), "sem_init" );
    EQNULL( (void *)pthread_mutex_init( &fifo_mutex, NULL ), "pthread_mutex_init" );

}






/***** Thread beenden *****/
Audio_th::~Audio_th( void )
{

    EQNULL( (void *)sem_destroy( &fifo_bereit ), "sem_destroy" );
    EQNULL( (void *)pthread_mutex_destroy( &fifo_mutex ), "pthread_mutex_destroy" );

    /* Puffer freigeben */
    if( fifo != NULL ){
        delete[] fifo;
    }

}








/****************************************************************************************/
/***** virtuelle Methoden ***************************************************************/
/****************************************************************************************/
int Audio_th::get( int16_t **&demux )
{
    return 0;
}


void Audio_th::release( void )
{
    return;
}






/****************************************************************************************/
/***** Optionen *************************************************************************/
/****************************************************************************************/

void Audio_th::Rate( int r )
{
    sound_rate = r;
}



void Audio_th::Bits( int b )
{
    sound_bits = b;
}



void Audio_th::Channels( int c )
{
    sound_channels = c;
}
