#ifndef _AUDIO_TH_H_
#define _AUDIO_TH_H_

#include <limits.h>
#include <semaphore.h>

#include "grab_Thread.h"


class Audio_th: public grab_Thread {
public:
    // Konstruktor / Destruktor
    Audio_th();
    virtual ~Audio_th();

    /* Daten lesen */
    virtual int get( int16_t **&demux );

    /* Puffer freigeben */
    virtual void release( void );

    /* Optionen einstellen */
    virtual void Rate( int r );
    virtual void Bits( int b );
    virtual void Channels( int c );

    /** aufgenommene Audiodaten ber Soundkarte wieder ausgeben
      */
    virtual void MonitorAudio( bool monitor ) { monitor_audio = monitor; }

protected:
    /* variablen */
    int sound_rate;
    int sound_bits;
    int sound_channels;
    bool monitor_audio;

    // Puffer
    int *fifo;
    pthread_mutex_t fifo_mutex;
    sem_t fifo_bereit;
};

#endif
