/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Ein Chunk in der Avi-Datei                               *****
\********************************************************************/

#ifndef _RIFF_CHUNK_H_
#define _RIFF_CHUNK_H_


#include <inttypes.h>
#include <unistd.h>

#include "RIFF_File.h"

class RIFF_Chunk {
public:
    RIFF_Chunk();
    virtual ~RIFF_Chunk();

    /**Einlesen der Datenstruktur aus einem Puffer der Lnge length
      */
    virtual bool Read( uint8_t *buf, size_t length )
    { return false; };

    /**Schreiben der Datenstruktur in einem Puffer der Lnge length
      */
    virtual bool Write( uint8_t *buf, size_t length )
    { return false; };

    /**Einlesen der Datenstruktur aus einer Datei<br>
      *length wird um die Anzahl der gelesenen Bytes dekrementiert
      */
    virtual bool ReadStream( RIFF_File *file, size_t &length );
    
    /**Schreiben der Datenstruktur in einer Datei<br>
      *length wird um die Anzahl der geschriebenen Bytes dekrementiert
      */
    virtual bool WriteStream( RIFF_File *file, size_t &length );
 
    /**liefert die Gre der Daten im Chunk
      */
    virtual size_t Size(void) { return 0; }

private:
    uint8_t *buf;
};

#endif
