/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Chunk-Header in einer RIFF-Datei                         *****
\********************************************************************/


#include <string.h>

#include "RIFF_Header.h"
#include "debug.h"



RIFF_Header::RIFF_Header()
{
    // Datenstruktur
    Type = 0;
    Length = 4;
    DataType = 0;

    // Offset des Headers
    Offset = 0;
}






    

/**Einlesen der Datenstruktur aus einem Puffer
  */
bool RIFF_Header::Read( uint8_t *buf, size_t length )
{
    if( length < Size() )
        return false;

    read_int( Type, buf, length );
    read_int( Length, buf, length );
    read_int( DataType, buf, length );

    DEBUG_TXT( "RIFF-Chunk-Header gelesen" );

    return true;
}





/**Schreiben der Datenstruktur in einen Puffer
  */
bool RIFF_Header::Write( uint8_t *buf, size_t length )
{
    if( length < Size() )
        return false;

    write_int( Type, buf, length );
    write_int( Length, buf, length );
    write_int( DataType, buf, length );

    return true;
}
