/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Chunk-Header in einer RIFF-Datei                         *****
\********************************************************************/

#ifndef _RIFF_HEADER_H_
#define _RIFF_HEADER_H_


#include "RIFF_Chunk.h"
#include "RIFF_ITypes.h"


class RIFF_Header: public RIFF_Chunk, public RIFF_ITypes {
public:
    RIFF_Header();
    //~RIFF_Header();

    // Datenstruktur
    uint32_t     Type;                  // Format-Code "RIFF"
    uint32_t     Length;                // Datengre
    uint32_t     DataType;              // Datentyp

    // Offset des Headers
    uint64_t Offset;
    
    // Methoden
    /**Einlesen der Datenstruktur aus einem Puffer
      */
    bool Read( uint8_t *buf, size_t length );

    /**Schreiben der Datenstruktur in einen Puffer
      */
    bool Write( uint8_t *buf, size_t length );

    /**liefert die Gre des Datenpuffers
      */
    size_t Size(void) { return 12; }

    /**Offset der Daten
      */
    uint64_t DataOffset( void ) { return Offset + Size(); }

    /**Gre der Daten
      */
    uint32_t DataSize( void ) { return Length - 4; }

    /**Gre der Daten
      */
    void SetDataSize( uint32_t bytes ) { Length = bytes + 4; }
    


};

#endif
