/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp AVI-Header                                      *****
\********************************************************************/

#ifndef _WAVE_FORMAT_H_
#define _WAVE_FORMAT_H_


#include "RIFF_Chunk.h"
#include "RIFF_ITypes.h"


class WaveFormat: public RIFF_Chunk, RIFF_ITypes {
public:
    WaveFormat();
    ~WaveFormat();

    // Datenstruktur
    uint16_t     Format;                // Format-Code des Audio-Codecs
    uint16_t     Channels;              // Kanle
    uint32_t     SamplesPerSec;         // Samplerate
    uint32_t     AvgBytesPerSec;        // Bytes pro Sekunde
    uint16_t     BlockAlign;            // ?
    uint16_t     BitsPerSample;         // 16 oder 8 (oder 0 bei variabler Bitrate?)
    uint16_t     DataSize;              // Gre des folgenden Datenblockes
    uint8_t      *Data;                 // zustzliche Daten fr den Audio-Codec

    
    // Methoden
    /**Einlesen der Datenstruktur aus einem Puffer
      */
    bool Read( uint8_t *buf, size_t length );

    /**Schreiben der Datenstruktur in einen Puffer
      */
    bool Write( uint8_t *buf, size_t length );

    /**liefert die Gre des Datenpuffers
      */
    size_t Size(void) { return 18 + DataSize; }

    /**Werte Ausgeben
      */
    void printInfo( void );

};

#endif
