/********************************************************************\
*****   Basisklasse fr Audio-Codec                              *****
\********************************************************************/

#ifndef _IMA4_CODEC_H_
#define _IMA4_CODEC_H_


#include <sys/types.h>
#include <inttypes.h>

#include "VideoFile/VideoFile.h"



class Ima4Codec: public A_Codec {
public:
    Ima4Codec( A_Track *Track );

    virtual ~Ima4Codec();

protected:
    // Audiodaten schreiben
    int encode( float **daten, int samples );

    // Audiodaten lesen
    int decode( float **daten, int samples );

private:
    unsigned char *puffer;
    long puffer_gr;
    static const int ima4_step[89];
    static const int ima4_index[16];
    
    // Starting information for all channels during encoding. 
    int *last_samples, *last_indexes;
    int16_t **work_buffer;
    int samples_in_buffer;
    
    void ima4_encode_block( unsigned char *output, int16_t *input, int channel);
    void ima4_encode_sample(int *last_sample, int *last_index, int *nibble, int next_sample);
    void ima4_decode_block( int16_t *output, uint8_t *input );
    void ima4_decode_sample(int *predictor, int *nibble, int *index, int *step);
};

#endif
