/********************************************************************\
*****   Basisklasse fr Audio-Codec                              *****
\********************************************************************/

#ifndef _LAME_CODEC_H_
#define _LAME_CODEC_H_


#include <sys/types.h>
#include <inttypes.h>

#include "VideoFile/VideoFile.h"




extern "C"
{
#include "lame3.70/lame.h"
#include "mpglib/interface.h"
}


class VideoFile;
class A_Track;

class LameCodec: public A_Codec {
public:
    LameCodec( A_Track *Track );

    ~LameCodec();

    int GetExtraInfo( uint8_t *&info, unsigned int &size );

    int SeekSample( int64_t sample );

protected:
    // Audiodaten schreiben
    int encode( float **daten, int sampels );

    // Audiodaten lesen
    int decode( float **daten, int sampels );

    // Optionen setzen
    int SetOption( OptionEntry *opt );

private:
    lame_global_flags encoder;
    struct mpstr decoder;
    unsigned char *puffer;
    long puffer_gr;

    int16_t **encoder_puffer;
    long encoder_puffer_gr;
    int encoder_puffer_start;

    char *decoder_puffer;
    int decoder_puffer_pos;
    int decoder_puffer_rest;
    static const long decoder_puffer_gr = 8192;

    int bitrate;

    uint8_t *format_info;
};


#endif
