/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp AVI-Header                                      *****
\********************************************************************/


#include <string.h>

#include "mp3Format.h"
#include "debug.h"



Mp3Format::Mp3Format()
{
    // Datenstruktur
    ID = 0;
    Flags = 0;
    BlockSize = 0;
    FramesPerBlock = 0;
    CodecDelay = 0;
}





    

/**Einlesen der Datenstruktur aus einem Puffer
  */
bool Mp3Format::Read( uint8_t *buf, size_t &length )
{
    if( length < Size() )
        return false;

    read_int( ID, buf, length );
    read_int( Flags, buf, length );
    read_int( BlockSize, buf, length );
    read_int( FramesPerBlock, buf, length );
    read_int( CodecDelay, buf, length );

    DEBUG_TXT( "Wave-Format gelesen" );
    //DEBUG_PROC( printInfo() );

    return true;
}





/**Schreiben der Datenstruktur in einen Puffer
  */
bool Mp3Format::Write( uint8_t *buf, size_t &length )
{
    if( length < Size() )
        return false;

    write_int( ID, buf, length );
    write_int( Flags, buf, length );
    write_int( BlockSize, buf, length );
    write_int( FramesPerBlock, buf, length );
    write_int( CodecDelay, buf, length );

    return true;
}

