#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "LameCodec.h"


static PluginList<Codec_Info> *Info;


A_Codec *create_codec( A_Track *track )
{
    return new LameCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;

    String Text = _("decode and encode mp3-audio");

    //                        DateiTyp     Codecalias  Kontruktor     Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info(  "Avi",       "mp3",      &create_codec, "0055",    Text,        true,  true );
    *Info += new Codec_Info(  "mp3",       "mp3",      &create_codec, "mp3",     Text,        true,  true );
    *Info += new Codec_Info(  "Mpeg",      "mp3",      &create_codec, "mp3",     Text,        true,  true );
    //*Info += new Codec_Info(  "Quicktime", "mp3",      &create_codec, ".mp3",    Text,        true,  true );
    
    Text = _("decode mp2-audio");

    *Info += new Codec_Info(  "Avi",       "mp2",      &create_codec, "0050",    Text,        true,  false );    
    *Info += new Codec_Info(  "mp3",       "mp2",      &create_codec, "mp2",     Text,        true,  false );
    *Info += new Codec_Info(  "Mpeg",      "mp2",      &create_codec, "mp2",     Text,        true,  false );
    
    return "A_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}



