#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "PcmCodec.h"


static PluginList<Codec_Info> *Info;


A_Codec *create_codec( A_Track *track )
{
    return new PcmCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;
    
    String Text = _("read and write raw-pcm-audio with 16 bit samples");

    //                        DateiTyp    Codecalias  Kontruktor     Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info( "Avi",       "pcm", &create_codec,      "0001",    Text );
    *Info += new Codec_Info( "Wav",       "pcm", &create_codec,      "0001",    Text );
    *Info += new Codec_Info( "Quicktime", "pcm", &create_codec,      "twos",    Text );
    
    return "A_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}



