/********************************************************************\
*****   Basisklasse fr Audio-Codec                              *****
\********************************************************************/

#ifndef _ULAW_CODEC_H_
#define _ULAW_CODEC_H_


#include <sys/types.h>
#include <inttypes.h>

#include "VideoFile/VideoFile.h"



class UlawCodec: public A_Codec {
public:
    UlawCodec( A_Track *Track );

    virtual ~UlawCodec();

protected:
    // Audiodaten schreiben
    int encode( float **daten, int samples );

    // Audiodaten lesen
    int decode( float **daten, int samples );

private:
    unsigned char *puffer;
    long puffer_gr;
    
    typedef struct
    {
        int16_t *ulawtoint16_table;
        int16_t *ulawtoint16_ptr;
        unsigned char *int16toulaw_table;
        unsigned char *int16toulaw_ptr;
    } Param;
    
    Param tables;
    
    int ulaw_init_ulawtoint16( void );
    int ulaw_init_int16toulaw( void );
};

#endif
