#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "UlawCodec.h"


static PluginList<Codec_Info> *Info;


A_Codec *create_codec( A_Track *track )
{
    return new UlawCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;
    
    String Text = _("read and write ulaw-Aaudio");

    //                        DateiTyp    Codecalias  Kontruktor     Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info( "Avi",       "ulaw", &create_codec,      "0007",    Text );
    *Info += new Codec_Info( "Wav",       "ulaw", &create_codec,      "0007",    Text );
    *Info += new Codec_Info( "Quicktime", "ulaw", &create_codec,      "ulaw",    Text );
    
    return "A_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
