/********************************************************

	Classes for writing AVIs
	Copyright 2000 Eugene Kuznetsov  (divx@euro.ru)

*********************************************************/
#ifndef _AVIWRITEFILE_H
#define _AVIWRITEFILE_H


#include "avifmt.h"
#include "default.h"
#include "avifile.h"
#include "formats.h"
#include "FileBuffer.h"

using namespace std;

#include <vector>
//using std::vector;


//
//maintains global file info
//
class AviSegWriteFile;
class AviWriteStream;

class AviWriteFile
{
friend class AviWriteStream;
friend class AviSegWriteFile;
private:
    vector<AviWriteStream*> m_streams;
    int m_strcnt;
    MainAVIHeader m_header;
    int m_status;
    vector<AVIINDEXENTRY> m_index;
protected:
    FileBuffer* m_fd;
//    int m_fd;
    void _destruct();
public:
    AviWriteFile(const char* name, int flags=0, int mask=00777);
    ~AviWriteFile();
    void WriteHeaders();

    AviWriteStream* AddAudioStream( const char *format, unsigned int format_size, int flags=0 );
    AviWriteStream* AddVideoStream( const char *format, unsigned int format_size,
                                    double frame_rate, int flags=0 );
    /*
    AviWriteStream* AddStream( enum AviStream::StreamType type,
                               const char* format, Unsigned format_size,
                               int handler, int frame_rate,
                               int samplesize=0, int quality=0, int flags=0 );
    */
    long long FileSize();

    //
    //called when data is added to stream
    //
    void AddChunk(offset_t offset, Unsigned size, Unsigned id, Unsigned flags=0);
};

#endif
