/********************************************************

	Classes for writing AVIs
	Copyright 2000 Eugene Kuznetsov  (divx@euro.ru)

*********************************************************/
#ifndef _AVIWRITESTREAM_H
#define _AVIWRITESTREAM_H

#include "avifmt.h"
#include "default.h"
#include "avifile.h"
#include "formats.h"
#include "FileBuffer.h"

using namespace std;

class AviWriteFile;

class AviWriteStream: public AviStream {
    friend class AviWriteFile;
protected:
    AviWriteFile* m_file;
    FileBuffer* m_fd;
    StreamType m_type;
    
    char* m_format;
    Unsigned m_forsize;
    int m_ckid;

public:
    // for video streams, specify time in microsecs per frame in frame_rate
    // for audio streams - count of bytes per second
    AviWriteStream( AviWriteFile* file, int ckid,
                                enum AviStream::StreamType type,
                                const char* format, unsigned int format_size,
                                double frame_rate, int flags=0 );

    ~AviWriteStream();

    StreamType GetType() const
    {
        return m_type;
    }

    HRESULT AddChunk(const char* chunk, Unsigned size, Unsigned flags=0);

    void SetFrameRate( double frame_rate );
    void SetBytesPerSec( int byterate );
    unsigned int GetFormatInfo( char *&format );

    Unsigned GetLength()//0 on error
    {
        return m_header.dwLength;
    }
};

#endif
