#ifndef _FILEBUFFER_H_
#define _FILEBUFFER_H_

#include <stdio.h>
#include <fcntl.h>
#include <iostream>

#include <unistd.h>

#include "except.h"
#define __MODULE__ "File buffer"
class FileBuffer
{
    int _fd;
public:
    FileBuffer( const char* fn, int mode=O_WRONLY | O_TRUNC | O_CREAT, 
                int mask=00644 )
    {
        _fd=open(fn, mode, mask);
        if(_fd<0)throw FATAL("Could not open file");

    }
    
    int sync()
    {
        return 0;
    }
    
    int lseek(int offset, int whence)
    {
        return ::lseek(_fd, offset, whence);
    }

    int write(const void* buffer, int count)
    {
        return ::write(_fd, buffer, count);
    }

    void write_int(int value)
    {
        ::write(_fd, &value, 4);
    }

    ~FileBuffer()
    {
        close(_fd);
    }
};

#undef __MODULE__

#endif
