#include "InputStream.h"

#include <iostream>
using std::iostream;

#include <fcntl.h>
#include <unistd.h>




InputStream::InputStream(int fd, int fd_async):m_fd(fd),m_fd_async(fd_async)
{
#ifdef USE_CACHE
    cache = new AVICache(BUFFERING);
#endif
    int pos=lseek64(m_fd, 0, SEEK_CUR);
    length=lseek64(m_fd, 0, SEEK_END);
    seek(pos);
}





InputStream::~InputStream()
{
#ifdef USE_CACHE
    if(cache)
        delete cache;
    cache=0;
#endif
}



int InputStream::Read(char* buffer, Unsigned size)
{
    int ans=read(m_fd, buffer, size);
    return ans;
}



offset_t InputStream::seek(__int64 offset)
{
    return lseek64(m_fd, offset, SEEK_SET);
}
offset_t InputStream::seek_cur(__int64 offset)
{
    return lseek64(m_fd, offset, SEEK_CUR);
}
offset_t InputStream::pos()
{
    return lseek64(m_fd, 0, SEEK_CUR);
}

int InputStream::read_int()
{
    int i;
    read(m_fd, &i, 4);
    return i;
}



int InputStream::AddStream(Unsigned id, AVIIndexEntry2 *table, Unsigned position, Unsigned length)
{
#ifdef USE_CACHE
    if(cache==0)return -1;
    return cache->AddStream(id, table, position, length);
#else
    m_streams.push_back(table);
    return 0;
#endif
}



int InputStream::Read(char* buffer, Unsigned id, Unsigned pos, Unsigned size, Unsigned offset )
{
#ifdef USE_CACHE
    if(cache==0)return -1;
    return cache->Read(buffer, id, pos, size, offset);
#else
    lseek64( m_fd, (m_streams[id])[pos].pos + 8 + offset, SEEK_SET);
    return ::read(m_fd, buffer, size);
#endif
}

