#ifndef _INPUTSTREAM_H_
#define _INPUTSTREAM_H_

#include "config.h"

#include <vector>
using std::vector;

#include "default.h"
#include "except.h"
#include "AVIIndex.h"

class InputStream
{
protected:
    int m_fd;
    int m_fd_async;
    __int64 length;
    vector<const AVIIndexEntry2 *> m_streams;

public:
    InputStream(int fd, int fd_async);
    ~InputStream();
    offset_t seek(__int64 offset);
    offset_t seek_cur(__int64 offset);
    offset_t pos();
    offset_t len() const{return length;}
    int eof(){return (pos()>=length);}
    int read_int();

    int Async() //enter asynchronous mode
    {
        return 0;
    }

    int AddStream(Unsigned id, AVIIndexEntry2 *table, Unsigned position, Unsigned length);

    int Read(char* buffer, Unsigned size);//synchronous
    //from cache:
    int Read(char* buffer, Unsigned id, Unsigned pos, Unsigned size, Unsigned offset =0);

    int Clear()
    {
        return 0;
    }
};

#endif
