#ifndef _DEFAULT_H
#define _DEFAULT_H

#include <inttypes.h>

typedef long HRESULT;
typedef int64_t offset_t;

#ifndef __WINE_WINERROR_H
#define E_NOTIMPL 			0x80004001
#define E_NOINTERFACE			0x80004002
#define E_INVALIDARG 			0x80004003
#define E_FAIL 				0x80004005
#define REGDB_E_CLASSNOTREG		0x80040154
#endif

#define VFW_E_INVALIDMEDIATYPE  	0x80040200
#define VFW_E_INVALIDSUBTYPE    	0x80040201
#define VFW_E_ALREADY_CONNECTED         0x80040204
#define VFW_E_FILTER_ACTIVE             0x80040205
#define VFW_E_NO_ACCEPTABLE_TYPES       0x80040207
#define VFW_E_NOT_CONNECTED             0x80040209
#define VFW_E_NO_ALLOCATOR              0x8004020A
#define VFW_E_NOT_RUNNING               0x80040226
#define VFW_E_TYPE_NOT_ACCEPTED         0x8004022A
#define VFW_E_SAMPLE_REJECTED           0x8004022B





#define E_ERROR -2

/*	divx codecs 	*/
#define fccDIV3 mmioFOURCC('D', 'I', 'V', '3')
#define fccDIV4 mmioFOURCC('D', 'I', 'V', '4')
#define fccdiv3 mmioFOURCC('d', 'i', 'v', '3')
#define fccdiv4 mmioFOURCC('d', 'i', 'v', '4')
#define fccMP41	mmioFOURCC('M', 'P', '4', '1')
#define fccMP43	mmioFOURCC('M', 'P', '4', '3')
/*	old ms mpeg-4 codecs */
#define fccMP42	mmioFOURCC('M', 'P', '4', '2')
#define fccmp42	mmioFOURCC('m', 'p', '4', '2')
#define fccmp43 mmioFOURCC('m', 'p', '4', '3')
#define fccmpg4	mmioFOURCC('m', 'p', 'g', '4')
#define fccMPG4	mmioFOURCC('M', 'P', 'G', '4')
/*	windows media codecs */
#define fccWMV1 mmioFOURCC('W', 'M', 'V', '1')
#define fccwmv1 mmioFOURCC('w', 'm', 'v', '1')
#define fccWMV2 mmioFOURCC('W', 'M', 'V', '2')
#define fccwmv2 mmioFOURCC('w', 'm', 'v', '2')
/*	other codecs	*/
#define fccIV32 mmioFOURCC('I', 'V', '3', '2')
#define fccIV41 mmioFOURCC('I', 'V', '4', '1')
#define fccIV50 mmioFOURCC('I', 'V', '5', '0')
#define fccI263 mmioFOURCC('I', '2', '6', '3')
#define fccCVID mmioFOURCC('c', 'v', 'i', 'd')
#define fccVCR2 mmioFOURCC('V', 'C', 'R', '2')
#define fccMJPG mmioFOURCC('M', 'J', 'P', 'G')
#define fccYUV  mmioFOURCC('Y', 'U', 'V', ' ')
#define fccYUY2 mmioFOURCC('Y', 'U', 'Y', '2')
#define fccYV12 mmioFOURCC('Y', 'V', '1', '2')/* Planar mode: Y + V + U  (3 planes) */
#define fccIYUV mmioFOURCC('I', 'Y', 'U', 'V')/* Planar mode: Y + U + V  (3 planes) */
#define fccUYVY mmioFOURCC('U', 'Y', 'V', 'Y')/* Packed mode: U0+Y0+V0+Y1 (1 plane) */
#define fccYVYU mmioFOURCC('Y', 'V', 'Y', 'U')/* Packed mode: Y0+V0+Y1+U0 (1 plane) */


#endif
