#include "config.h"

#include "avifmt.h"
#include "default.h"
#define _LARGEFILE64_SOURCE
#include <unistd.h>
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#else
#include <stdlib.h>
#endif
#include <string.h>
#include <stdio.h>
#include <pthread.h>
#include "except.h"

#include "AVIIndex.h"

#define BUFFERING 100

typedef long long __int64;
#define MAXSTREAMS 4
#ifdef __FreeBSD__
#define lseek64 lseek
//#else
//extern "C" __int64 lseek64(int fd, __int64 offset, int);
#endif

struct req
{
    __int64 offset;
    int size;
    enum status {
    BUFFER_CLEAN=0,
    BUFFER_WAITING,
    BUFFER_WRITING,
    BUFFER_READY
    };
    status st;
    Unsigned id;//number of stream
    Unsigned position;//position in stream
    char* memory;
};

class AVICache
{
    Unsigned m_size;
    Unsigned m_used;
    AVIIndexEntry2* m_tables[MAXSTREAMS];
    Unsigned m_lengths[MAXSTREAMS];
    __int64 m_positions[MAXSTREAMS];
    pthread_mutex_t mutex_in, mutex_out;
    pthread_cond_t cond_in, cond_out;    
    pthread_t thread;
    req* req_buf;
    int buffers_busy;
    int m_quit;
    int cache_access;
    int cache_right;
    int cache_miss;
    enum status {
    CLEAR,
    ASYNC
    };
    status m_status;    
protected:
    int Prefetch(Unsigned id, Unsigned position);
    int Update();//removes unused cache entries and requests newer ones
public:
    AVICache(Unsigned size);
    int AddStream(Unsigned id, AVIIndexEntry2 *table, Unsigned position, Unsigned length);
    ~AVICache();
    int Clear();
    int Create(int fd);
    int Read(char* buffer, Unsigned id, Unsigned pos, Unsigned size, Unsigned offset=0);
};


