/********************************************************************\
*****   Avi Audio-Track                                          *****
\********************************************************************/

#ifndef _AVI_ATR_H_
#define _AVI_ATR_H_

#include "Avi.h"
#include "Avi_Track.h"

#include "VideoFile/VideoFile.h"



class AviAtr: public A_Track{
public:

    AviAtr( AviIO *File, int track=0 );
    AviAtr( AviIO *File,
            int Sample_rate,
            int Channels,
            const char *Codec_name = NULL,
            int track = 0 );


    ~AviAtr();


    /**Audio-Position setzen
      */
    int Seek( long block );

    /**Zustzliche Informationen mitteilen<br>
      *der eigentliche Wert von "info" hngt vom Typ des IO-Moduls<br>
      *Diese Funktion sollte nur vom Codec aufgerufen werden<br>
      *ab! "size" gibt die Datenlnge an.<br>
      *Der Rckgabewert: 1 - info verstanden<br>
      *                  0 - sonst
      */
    int CodecExtraInfo( uint8_t *&info, unsigned int &size );


private:
    AviTrack *avi_track;

    uint8_t *buffer_data;
    long buffer_size;

    uint32_t sample_size;
    uint32_t bytes_per_sec;

    uint8_t *format_info;
    
protected:
    AviIO *file;
    
    int readRaw( unsigned char *&data, long &bytes );
    int writeRaw( unsigned char *data, long bytes, int samp );

};

#endif
