/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


#include "AVI_Index_Entry.h"



AviIndexEntry::AviIndexEntry()
{
    // Datenstruktur
    ID = 0;
    Flags = 0;
    ChunkOffset = 0;            // Position of chunk
    ChunkLength = 0;            // Length of chunk
}



AviIndexEntry::~AviIndexEntry()
{}

    


/**Einlesen der Datenstruktur aus einem Puffer
  */
bool AviIndexEntry::Read( uint8_t *buf, size_t length )
{
    if( length < Size() )
        return false;

    read_int( ID, buf, length );
    read_int( Flags, buf, length );
    read_int( ChunkOffset, buf, length );
    read_int( ChunkLength, buf, length );

    return true;
}





/**Schreiben der Datenstruktur in einen Puffer
  */
bool AviIndexEntry::Write( uint8_t *buf, size_t length )
{
    if( length < Size() )
        return false;

    write_int( ID, buf, length );
    write_int( Flags, buf, length );
    write_int( ChunkOffset, buf, length );
    write_int( ChunkLength, buf, length );

    return true;
}



/**Nummer des Tracks
  */
unsigned int AviIndexEntry::StreamNum(void)
{
    return stream_num( ID );
}
