/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp AVI-Header                                      *****
\********************************************************************/

#ifndef _AVI_INDEX_ENTRY_H_
#define _AVI_INDEX_ENTRY_H_

#include <inttypes.h>

#include "plugins/RIFFio/RIFF_Chunk.h"
#include "plugins/RIFFio/RIFF_ITypes.h"





class AviIndexEntry:public RIFF_Chunk, RIFF_ITypes {
public:
    AviIndexEntry();
    ~AviIndexEntry();

    // Datenstruktur
    uint32_t     ID;
    uint32_t     Flags;                  // Flags (s.o.)
    uint32_t     ChunkOffset;            // Position des Blocks (als uint32_t in Datei gespeichert)
    uint32_t     ChunkLength;            // Lnge des Blocks
    
    // Methoden

    /**Einlesen der Datenstruktur aus einem Puffer
      */
    bool Read( uint8_t *buf, size_t length );
    


    /**Schreiben der Datenstruktur in einen Puffer
      */
    bool Write( uint8_t *buf, size_t length );
    


    /**liefert die Gre des Datenpuffers
      */
    size_t Size(void) { return 16; }

    /**Nummer des Tracks
      */
    unsigned int StreamNum(void);
        
};

#endif
