/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp Bitmap-Info                                     *****
\********************************************************************/


#include "Bitmap_Info.h"
#include "debug.h"



BitmapInfo::BitmapInfo()
{
    Width = 640;
    Height = 480;
    Planes = 1;
    BitCount = 24;
    Compression = 0;
    SizeImage = 921600;
    XPelsPerMeter = 0;
    YPelsPerMeter = 0;
    ClrUsed = 0;
    ClrImportant = 0;
}


    


/**Einlesen der Datenstruktur aus einem Puffer
  */
bool BitmapInfo::Read( uint8_t *buf, size_t length )
{
    uint32_t s = 0;
    
    if( length < Size() )
        return false;

    // Da steht nochmal die Gre drin
    read_int( s, buf, length );
    
    read_int( Width, buf, length );
    read_int( Height, buf, length );
    read_int( Planes, buf, length );
    read_int( BitCount, buf, length );
    read_int( Compression, buf, length );
    read_int( SizeImage, buf, length );
    read_int( XPelsPerMeter, buf, length );
    read_int( YPelsPerMeter, buf, length );
    read_int( ClrUsed, buf, length );
    read_int( ClrImportant, buf, length );

    return true;
}







/**Schreiben der Datenstruktur in einen Puffer
  */
bool BitmapInfo::Write( uint8_t *buf, size_t length )
{
    if( length < Size() )
        return false;

    // zustzlich mu hier nochmal die Gre geschrieben werden!
    write_int( Size(), buf, length );
        
    write_int( Width, buf, length );
    write_int( Height, buf, length );
    write_int( Planes, buf, length );
    write_int( BitCount, buf, length );
    write_int( Compression, buf, length );
    write_int( SizeImage, buf, length );
    write_int( XPelsPerMeter, buf, length );
    write_int( YPelsPerMeter, buf, length );
    write_int( ClrUsed, buf, length );
    write_int( ClrImportant, buf, length );

    return true;
}







/**Werte Ausgeben
  */
void BitmapInfo::printInfo( void )
{
    uint8_t Z[4];
    
    printf( "    Width = %i\n", Width );
    printf( "    Height = %i\n", Height );
    printf( "    Planes = %i\n", Planes );
    printf( "    BitCount = %i\n", BitCount );
    write_int( Compression, Z );
    printf( "    Compression = %c%c%c%c\n", Z[0], Z[1], Z[2], Z[3] );
    printf( "    SizeImage = %i\n", SizeImage );
    printf( "    XPelsPerMeter = %i\n", XPelsPerMeter );
    printf( "    YPelsPerMeter = %i\n", YPelsPerMeter );
    printf( "    ClrUsed = %i\n", ClrUsed );
    printf( "    ClrImportant = %i\n", ClrImportant );
}
