/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp Bitmap-Info                                     *****
\********************************************************************/

#ifndef _BITMAP_INFO_H_
#define _BITMAP_INFO_H_

#include "plugins/RIFFio/RIFF_Chunk.h"
#include "plugins/RIFFio/RIFF_ITypes.h"


class BitmapInfo: public RIFF_Chunk, RIFF_ITypes {
public:
    BitmapInfo();
    //~BitmapInfo();

    // Datenstruktur
    //uint32_t     Size;                // Da steht nochmal die Gre dieser Struktur
                                        // Das ist eigentlich vllig berflssig...
    uint32_t     Width;                 // Bildabmessungen
    uint32_t     Height;                //
    uint16_t     Planes;                // Farbkomponenten
    uint16_t     BitCount;              // Bit pro Bildpunkt?
    uint32_t     Compression;           // Kennung des Codecs (schonwieder!)
    uint32_t     SizeImage;             // Bytes eines unkompremierten Bildes
    uint32_t     XPelsPerMeter;         // ?
    uint32_t     YPelsPerMeter;         // ?
    uint32_t     ClrUsed;               // ?
    uint32_t     ClrImportant;          // ?
    

    // Methoden
    /**Einlesen der Datenstruktur aus einem Puffer
      */
    bool Read( uint8_t *buf, size_t length );

    /**Schreiben der Datenstruktur in einen Puffer
      */
    bool Write( uint8_t *buf, size_t length );

    /**liefert die Gre des Datenpuffers
      */
    size_t Size(void) { return 40; }

    /**Werte Ausgeben
      */
    void printInfo( void );

private:

};

#endif
