/********************************************************************\
*****   Methoden fr IO in Avi Dateien                           *****
*****   Datentyp AVI-Header                                      *****
\********************************************************************/

#ifndef _STREAM_HEADER_H_
#define _STREAM_HEADER_H_

#include <inttypes.h>
#include "plugins/RIFFio/RIFF_Chunk.h"
#include "plugins/RIFFio/RIFF_ITypes.h"


class StreamHeader: public RIFF_Chunk, RIFF_ITypes {
public:
    StreamHeader();
    //~StreamHeader();

    // Datenstruktur
    uint32_t     StreamType;           // vids, auds, ... fr Video, Audio, ...
    uint32_t     StreamHandler;        // bei Video die Kennung des Codecs
                                       // (das gleiche wie in BitmapInfo - schonwieder
                                       // sowas sinnloses!) bei Audio =0
    uint32_t     Flags;
    uint16_t     Priority;             // Priority - splited for audio
    uint16_t     Language;
    uint32_t     InitialFrames;
    uint32_t     Scale;
    uint32_t     Rate;                 // Rate/Scale = Frames/sec (fr Video und
                                       //              Audio bei SampleSize=0)
                                       //            = (Bytes / sec) / SampleSize fr
                                       //              Audio bei SampleSize!=0
    uint32_t     Start;
    uint32_t     Length;               // Azahl der Frames (Video und Audio bei SampleSize=0)
                                       // oder Lnge in Sekunden = Length/FrameRate (Audio)
    uint32_t     SuggestedBufferSize;
    uint32_t     Quality;
    uint32_t     SampleSize;           // Bytes/Sample = 0 fr Video
                                       //              = 0 oder Bytes/Sample fr Audio
    uint16_t     left;                 // Bild-Format = 0
    uint16_t     top;                  // = 0
    uint16_t     right;                // = Breite (das gleich wie in BitmapInfo)
    uint16_t     bottom;               // = Hhe (das gleich wie in BitmapInfo)


    // Methoden
    /**Einlesen der Datenstruktur aus einem Puffer
      */
    bool Read( uint8_t *buf, size_t length );

    /**Schreiben der Datenstruktur in einen Puffer
      */
    bool Write( uint8_t *buf, size_t length );

    /**liefert die Gre des Datenpuffers
      */
    size_t Size(void) { return 56; }

    /**Werte Ausgeben
      */
    void printInfo( void );
    
};


#endif
