/********************************************************************\
*****   Audio / Video - Track fr Mpeg-1/2 Dateien               *****
\********************************************************************/

#ifndef _MPEG_TRACK_H_
#define _MPEG_TRACK_H_

using namespace std;

#include <fstream>

#include "Mpeg.h"
#include "keytable.h"

#include "VideoFile/VideoFile.h"



class MpegTrack: public virtual Track {
    friend class MpegIO;
public:

    MpegTrack( MpegIO *File, StreamPuffer *buf, int track=0 );
    MpegTrack( MpegIO *File, double rate, const char *Codec_name, int track=0 );

    ~MpegTrack();

    int Seek( long block );

    StreamPuffer *stream;       // Daten-Puffer

    System *system;
    FilePuffer *puffer;
    
protected:
    KeyTable key_table;         // Liste mit I-Frames
    long max_pos;

    MpegIO *file;
private:
    //initialisieren - wird vom Konstruktor aufgerufen
    void init( MpegIO *File, StreamPuffer *buf );

    /**Stream Puffer positionieren<br>
      *Rckgabe:  1  erfolgreich positioniert<br>
      *           0  kann nicht positionieren - andere Methode probieren!<br>
      *          -1  Fehler
      */
    int seek_time( double sec, off_t offset = -1 );

};

#endif
