/********************************************************************\
*****   Audiotrack fr Mpeg-1/2 Dateien                          *****
\********************************************************************/

#ifndef _MPEG_ATR_H_
#define _MPEG_ATR_H_

using namespace std;
#include <fstream>

#include "Mpeg.h"
#include "MpegTrack.h"

#include "VideoFile/VideoFile.h"



class MpegAtr: public MpegTrack, public A_Track {
public:

    MpegAtr( MpegIO *File, int track );
    MpegAtr( MpegIO *File,
             int Sample_rate,
             int Channels,
             const char *Codec_name,
             int track = 0 );


    ~MpegAtr();


    // Audio-Position setzen
    int Seek( long block );

private:
    uint8_t *puffer;            // Puffer fr gelesene MP3-Daten
    long puffer_gr;             // Gre des Puffers

    int framesize;              // Gre eines MP3-Datenblocks
    int layer;                  // mpeg-Layer
    uint32_t mp3_block_start;   // Header des ersten mp3-Blocks
    
    bool sync_block_start_mp3( void );
    int decode_header_mp3( uint32_t head );
    int get_block_mp3( void );

    bool sync_block_start_ac3( void );
    int decode_header_ac3( uint8_t *buf, double &blockrate, int &samplerate, int &ch, int &bit_rate );
    int get_block_ac3( void );

protected:
    int readRaw( unsigned char *&data, long &bytes );
    int writeRaw( unsigned char *data, long bytes, int samp );
};

#endif
