#include <unistd.h>

#include "VideoFile/VideoFile.h"
#include "VideoFile/PluginList.h"
#include "VideoFile/IOModul_Info.h"
#include "VideoFile/translate.h"

#include "Mpeg.h"


static PluginList<IOModul_Info> *Info;


VideoFile *create_modul_mpeg1( const String file, VideoFile::IO_Mode mode )
{
    return new MpegIO( file, mode, 1 );
}


VideoFile *create_modul_mpeg2( const String file, VideoFile::IO_Mode mode )
{
    return new MpegIO( file, mode, 2 );
}




extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<IOModul_Info>;
    
    String Text = _("Mpeg-system streams (use filename \"-\" for stdin/stdout)");

    *Info += IOModul_Info( "Mpeg", &create_modul_mpeg1, Text );
    *Info += IOModul_Info( "Mpeg1", &create_modul_mpeg1, Text );
    *Info += IOModul_Info( "Mpeg2", &create_modul_mpeg2, Text );
    
    return "VideoFile";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
