/********************************************************************\
*****   Methoden fr IO in MPPEG-Video Dateien                   *****
\********************************************************************/

#ifndef _PUFFER_H_
#define _PUFFER_H_

#include <inttypes.h>
#include <unistd.h>

class FifoPuffer {
public:
    FifoPuffer();
    virtual ~FifoPuffer();

    /**Puffer um n Bytes weiterschieben
      */
    virtual void ClearData( size_t n );

    /**Puffer leeren
      */
    virtual void Reset( void );

    /**Finde "muster" im Puffer<br>
      *gesucht wird ab der Position "offset"<br>
      *Rckgabe: Anfangsposition<br>
      *          oder -1, wenn nicht gefunden
      */
    virtual long Finden( size_t offset, const unsigned char *muster, size_t n );

    /**Finde "muster" im Puffer<br>
      *Verglichen werden nur die Bits aus "maske", die 1 sind<br>
      *gesucht wird ab der Position "offset"<br>
      *das gefundene Muster wird in "&gefunden" gespeichert
      *Rckgabe: Anfangsposition<br>
      *          oder -1, wenn nicht gefunden
      */
    long Finden( size_t offset, uint32_t muster, uint32_t maske, uint32_t &gefunden );

    /**Zeiger auf Datenfeld an Stelle "offset"
      */
    virtual uint8_t Data( size_t offset );

    /**Daten aus Puffer kopieren<br>
      *kopiert n Bytes aus dem Puffer in Position offset<br>
      *in das Datenfeld *data<br>
      *Rckgabe:  1  Daten gelesen<br>
      *          -1  Fehler
      */
    virtual int GetData( size_t offset, uint8_t *data, size_t n );

    /**Bytes im Puffer  
      */
    virtual size_t Bytes( void ) { return bytes; }

protected:
    size_t bytes;               // Bytes in Puffer
};

#endif
