#include <unistd.h>

#include "VideoFile/VideoFile.h"
#include "VideoFile/PluginList.h"
#include "VideoFile/IOModul_Info.h"
#include "VideoFile/translate.h"

#include "OQuicktime.h"


static PluginList<IOModul_Info> *Info;


VideoFile *create_modul( const String file, VideoFile::IO_Mode mode )
{
    return new OQuicktimeIO( file, mode );
}




extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<IOModul_Info>;
    
    String Text = _("Quicktime files, audio and video");
    
    *Info += IOModul_Info( "QT", &create_modul, Text );
    
    return "VideoFile";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}



