/********************************************************************\
*****   Methoden fr IO in MP3 Dateien                           *****
\********************************************************************/

#ifndef _MP3_H_
#define _MP3_H_

using namespace std;

#include <fstream>
#include "VideoFile/VideoFile.h"


class mp3Atr;


class mp3IO:public VideoFile {
    friend class mp3Atr;
public:
    mp3IO( const String datei, IO_Mode mode=write );
    ~mp3IO();

protected:
    /*** Audiofunktionen ***/
    // Audio codec initialisieren
    A_Track *openAudioTrack( int Sample_rate,
                             int Channels,
                             const char *Codec = NULL );
                             
    // Audio-Track ffnen
    A_Track *openAudioTrack( int track );

private:
    fstream *mp3_datei;         // Datei - lesen/schreiben
    istream *mp3_istream;       // Stream - lesen (stdin)
    ostream *mp3_ostream;       // Stream - schreiben (stout)

    bool sync_block_start( void );
    int decode_header( unsigned long header );
    uint32_t mp3_block_start;

    int layer, framesize;
};






class mp3Atr:public A_Track {
public:

    mp3Atr( mp3IO *File );
    mp3Atr( mp3IO *File,
            int Sample_rate,
            int Channels,
            const char *Codec_name );


    ~mp3Atr();


    // Audio-Position setzen
    int Seek( long block );

private:
    mp3IO *file;

    unsigned char *puffer;      // Puffer fr gelesene MP3-Daten
    long puffer_gr;             // Gre des Puffers
    long puffer_block_len;      // Lnge eines MP3-Blocks
    long puffer_bytes;          // Bytes in Puffer
    void puffer_schieben( long bytes );
    long puffer_finden( size_t start, uint32_t muster, uint32_t maske, uint32_t &gefunden );
    int puffer_fuellen( void );

protected:
    int readRaw( unsigned char *&data, long &bytes );
    int writeRaw( unsigned char *data, long bytes, int samp );
};

#endif
