#include <unistd.h>

#include "VideoFile/VideoFile.h"
#include "VideoFile/PluginList.h"
#include "VideoFile/IOModul_Info.h"
#include "VideoFile/translate.h"

#include "mp3.h"


static PluginList<IOModul_Info> *Info;


VideoFile *create_modul( const String file, VideoFile::IO_Mode mode )
{
    return new mp3IO( file, mode );
}




extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<IOModul_Info>;
    
    String Text = _("mp3 and mp2 audio files (use filename \"-\" for stdin/stdout)");
        
    *Info += IOModul_Info( "mp3", &create_modul, Text );
    // *Info += IOModul_Info( "mp2", &create_modul, Text );
    
    return "VideoFile";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
