/********************************************************************\
*****   Methoden fr IO in MPPEG-Video Dateien                   *****
\********************************************************************/

#ifndef _CHUNK_H_
#define _CHUNK_H_

#include "puffer.h"


#define PICTURE_START_CODE 0x00
#define SEQUENCE_HEADER_CODE 0xb3
#define SYSTEM_HEADER_CODE 0xb9



class Chunk {
public:
    Chunk( FifoPuffer *Puffer);
    ~Chunk();

    /**Den nchsten Block aus dem Puffer in das Datenfeld kopieren<br>
      *Rckgabe: >0  erfolg<br>
      *           0  keine weiteren Daten<br>
      *          -1  Fehler
      */
    int Lesen( uint8_t *data, size_t &bytes );

    /**Liefert den Startcode des nchsten Blocks<br>
      *Rckgabe: >=0  Startcode<br>
      *           -1  Fehler
      */
    int Startcode( void );

    /**berspringt den nchsten Block
      */
    int Skip( void );

    /**Bytes im nchsten Block
      */
    long Bytes( void );

    /**Zeichen an Offset im Chunk
      */
    uint8_t Data( size_t offset );
    
private:
    /**Auf den Start eines Blockes synchronisieren<br>
      *Rckgabe: >0 Erfolg<br>
      *           0 keine weiteren Daten<br>
      *          -1 Fehler
      */
    int Sync( void );
    
    FifoPuffer *puffer;
};

#endif
