/*****************************************************************************\
**  Author  : Christian Tusche                                               **
**  E-Mail  : ctusche@gmx.net                        **
**                                                                           **
** This program is free software; you can redistribute it and/or modify      **
** it under the terms of the GNU General Public License as published by      **
** the Free Software Foundation; either version 2 of the License, or         **
** (at your option) any later version.                                       **
**                                                                           **
** This program is distributed in the hope that it will be useful,           **
** but WITHOUT ANY WARRANTY; without even the implied warranty of            **
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             **
** GNU General Public License for more details.                              **
**                                                                           **
** You should have received a copy of the GNU General Public License         **
** along with this program; if not, write to the Free Software               **
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 **
\*****************************************************************************/


#include "keytable.h"
#include "debug.h"




KeyTable::KeyTable()
{

}



KeyTable::~KeyTable()
{
    while( table.size() > 0 ) {
        delete table.back();
        table.pop_back();
    }
}




void KeyTable::AddKeyFrame( long frame, long long offset )
{
    // suche nach Key-Frame in Tabelle
    unsigned int i;
    
    for( i=0; i < table.size(); i++ ) {
        if( table[i]->frame >= frame )
            break;
    }

    if( i < table.size() )
        return;
    
    key_entry *entry = new key_entry;

    entry->frame = frame;
    entry->offset = offset;

    table.push_back( entry );

    //DEBUG_TXT( "insert Keyframe %i" , frame );
}






long KeyTable::GetKeyFrame( long frame, long long &offset )
{
    long key = 0;
    unsigned int i;
    
    for( i=0; i<table.size(); i++ ) {
        if( table[i]->frame > frame )
            break;
    }

    if( i > 0 ) {
        key = table[i-1]->frame;
        offset = table[i-1]->offset;
    }

    //DEBUG_TXT( "get Keyframe %i" , key );
    
    return key;
}
