/********************************************************************\
*****   Methoden fr IO in MPPEG-Video Dateien                   *****
\********************************************************************/

#ifndef _PUFFER_H_
#define _PUFFER_H_

using namespace std;

#include <istream>
#include <inttypes.h>

class FifoPuffer {
public:
    FifoPuffer( istream *file, size_t gr );
    ~FifoPuffer();

    /**Puffer aus Eingabedatei fllen<br>
      *Rckgabe:  1  Daten gelesen<br>
      *           0  keine Daten gelesen / eof<br>
      *          -1  Fehler
      */
    int Fuellen( void );

    /**Puffer um n Bytes weiterschieben
      */
    void Schieben( size_t n );

    /**Puffer leeren
      */
    void Reset( void );

    /**Finde "muster" im Puffer<br>
      *gesucht wird ab der Position "offset"<br>
      *Rckgabe: Anfangsposition<br>
      *          oder -1, wenn nicht gefunden
      */
    long Finden( size_t offset, const unsigned char *muster, size_t n );

    /**Zeiger auf Datenfeld an Stelle "offset"
      */
    unsigned char *Data( size_t offset );

    /**Daten aus Puffer kopieren
      */
    void Kopieren( size_t offset, uint8_t *data, size_t n );

    /**Bytes im Puffer
      */
    long Bytes( void ) { return bytes; }

    /**End of File
      */
    bool Eof( void ) { return eof; }

private:
    unsigned char *puffer;      // Puffer fr gelesene MP3-Daten
    istream *datei;             // Datei aus der gelesen wird
    size_t groesse;             // Gre des Puffers
    size_t bytes;               // Bytes in Puffer
    size_t position;            // aktuelle Startposition der Daten
    bool eof;
};

#endif
