/********************************************************************\
*****   Methoden fr IO in Quicktime Dateien                     *****
\********************************************************************/

#ifndef _YUV_STREAM_H_
#define _YUV_STREAM_H_

#include "yuv4mpeg.h"

#include "VideoFile/VideoFile.h"


class yuvStreamV;
class yuvStreamVtr;


class yuvStream:public VideoFile {
    friend class yuvStreamV;
    friend class yuvStreamVtr;
public:
    yuvStream( const String file, IO_Mode mode = write );
    ~yuvStream();

protected:
    /*** Videofunktionen ***/
    // Video codec initialisieren
    //    Codec: Name des internen Videocodecs des Backends
    V_Track *openVideoTrack( double Rate,
                             int x, int y,
                             const char *Codec = NULL );
                             
    V_Track *openVideoTrack( int track );

    bool modus_schreiben;       // lesen / schreiben
    int fileno;

    int breite;
    int hoehe;
    int rate_code;
};







class yuvStreamVtr:public V_Track {
    friend class yuvStreamV;
public:
    yuvStreamVtr( yuvStream *File,
                  float rate,
                  int x, int y );
    yuvStreamVtr( yuvStream *File );

    ~yuvStreamVtr();
    // Bild-Position setzen
    int Seek( long block );

private:
    yuvStream *file;          // bergeordnete Klasse
    unsigned char *puffer;    // Datenpuffer fr gelesenes Bild

protected:
    // Rohdaten lesen und schreiben
    virtual int readRaw( unsigned char *&data, long &bytes );
    virtual int writeRaw( unsigned char *data, long bytes, int keyframe=0 );
};









class yuvStreamV:public V_Codec {
public:
    yuvStreamV( yuvStreamVtr *Track );

    ~yuvStreamV();

    // Farbraum
    bool ColorModel( int cmodel );

protected:
    // Video-Bild schreiben
    int encode( VideoFrame *bild );
    // Videobild lesen
    int decode( VideoFrame *bild );
};

#endif
