#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "DVCodec.h"


static PluginList<Codec_Info> *Info;


V_Codec *create_codec( V_Track *track )
{
    return new DVCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;
    
    String Text = _("decode DV video");

    //                        DateiTyp   Codecalias  Kontruktor     Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info( "Avi",      "DV-Video",     &create_codec, "dvsd",    Text,        true,  false );
    *Info += new Codec_Info( "Avi",      "DV-Video",     &create_codec, "DVSD",    Text,        true,  false );
    
    return "V_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}



