/********************************************************************\
*****   Audio-Codecs aus ffmpeg                                  *****
\********************************************************************/

#ifndef _PCM_CODEC_H_
#define _PCM_CODEC_H_


#include <sys/types.h>
#include <inttypes.h>

#include "VideoFile/VideoFile.h"

#include "libavcodec/avcodec.h"




class ffmpegAudio: public A_Codec {
public:
    ffmpegAudio( A_Track *Track );

    virtual ~ffmpegAudio();

    /**Positionieren
      */
    int SeekSample( int64_t sample );

    int GetExtraInfo( uint8_t *&info, unsigned int &size );


protected:
    // Audiodaten schreiben
    int encode( float **daten, int samples );

    // Audiodaten lesen
    int decode( float **daten, int samples );

    // Optionen setzen
    int SetOption( OptionEntry *opt );


private:
    // interne Puffer fr Daten und Samples
    uint8_t *puffer;
    long puffer_gr;
    short *sample_puffer;
    int frame_size, sample_rest, sample_pos;
    uint8_t *data;
    long data_pos, data_rest;
    
   uint8_t *format_info; 

    
    // Codec
    AVCodec *avcodec;
    AVCodecContext context;

    // Optionen
    int bitrate;

    bool init;

    // Codec ffnen und optionen setzen
    void init_codec( void );
};

#endif
