/***************************************************************************
                          ffmpegCodec.h  -  description
                             -------------------
    begin                : Sun Nov 25 2001
    copyright            : (C) 2001 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FFMPEGCODEC_H
#define FFMPEGCODEC_H

#include "VideoFile/VideoFile.h"


#include "libavcodec/avcodec.h"

/**Lesen und schreiben von Videoframes mit Hilfe von ffmepg
  *@author Christian Tusche
  */

class ffmpegCodec : public V_Codec  {
public: 
    ffmpegCodec( V_Track *Track );
    ~ffmpegCodec();

    /**Farbraum festlegen
      */
    bool ColorModel( int cmodel );

    /**Positionieren
      */
    int SeekFrame( long bild );
    
    /**Bild kopieren
      */
    int CopyFrame( void );

protected:
    /**Video-Bild schreiben
      */
    int encode( VideoFrame *bild );

    /**Video-Bild lesen
      */
    int decode( VideoFrame *bild );

    // Optionen setzen
    int SetOption( OptionEntry *opt );

private:
    unsigned char *data_buf;
    long data_buf_bytes;
    long data_bytes;

    uint8_t *frame_data;
    long frame_bytes;

    // Codec
    AVCodec *avcodec;
    AVCodecContext context;
    
    // Optionen
    int bitrate, min_quality, max_quality, gop_size, high_quality, motion_estimation;

    bool init;

    // Codec ffnen und optionen setzen
    void init_codec( void );
};

#endif
