/****************************************************************************************/
/***** Jpeg - Videocodec ******************************************************************/
/****************************************************************************************/

#ifndef _JPEGCODEC_H_
#define _JPEGCODEC_H_

#include <stdio.h>

extern "C" {
//#include <jpeg-mmx/jpeglib.h>
#include <jpeglib.h>
}

#include "VideoFile/VideoFile.h"

class JpegCodec:public V_Codec {
public:
    JpegCodec( V_Track *Track );

    ~JpegCodec();

    // Farbraum festlegen
    bool ColorModel( int cmodel );

    // Bild kopieren
    int CopyFrame( void );

private:
    // Jpeg-Qualitt
    bool jpegQuality( int q );

    unsigned char *out_data;          // Puffer fr kompremierte Ausgabedaten
    long out_bytes;                   // gre des verfgbaren Ausgabepuffers
    unsigned char *in_data;           // Puffer fr kompremierte Quelldaten
    long in_bytes;                    // gre des verfgbaren Eingangspuffers

    unsigned char **row_pointers;     // Zeiger auf Zeilen / YUV-Komponenten
    void erz_row_pointers( unsigned char **row_pointers, unsigned char *buf );

    // Datentypen fr raw-data
    JSAMPARRAY *Komponenten;

    struct jpeg_error_mgr jcerr;
    struct jpeg_compress_struct cinfo;
    struct jpeg_destination_mgr dest;

    struct jpeg_error_mgr jderr;
    struct jpeg_decompress_struct dinfo;
    struct jpeg_source_mgr source;

    // Funktionen fr Jpeglib
    static void init_destination( j_compress_ptr cinfo );
    static boolean empty_output_buffer( j_compress_ptr cinfo );
    static void term_destination( j_compress_ptr cinfo );
    static void init_source( j_decompress_ptr dinfo );
    static void skip_input_data ( j_decompress_ptr dinfo, long num_bytes );
    static boolean fill_input_buffer( j_decompress_ptr dinfo );
    static void term_source( j_decompress_ptr dinfo );

    // Konstante Paramenter
    static const bool jpeg_baseline;
    static const J_DCT_METHOD dct_method;

protected:
    // Video-Bild schreiben
    int encode( VideoFrame *bild );

    // Video-Bild lesen
    int decode( VideoFrame *bild );

    // Optionen setzen
    int SetOption( OptionEntry *opt );
};


#endif
