#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "MpegCodec.h"


static PluginList<Codec_Info> *Info;


V_Codec *create_codec( V_Track *track )
{
    return new MpegCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    
    Info = new PluginList<Codec_Info>;

    String Text = _("decode mpeg1/2 video");

    //                        DateiTyp   Codecalias    Kontruktor     Codecname      Beschreibung lesen  schreiben
    *Info += new Codec_Info( "MpegVideo", "Mpeg-1/2",  &create_codec, "Mpeg-1/2",    Text,        true,  false );
    
    return "V_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
