#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <errno.h>
#include <unistd.h>
#include <linux/videodev.h>
#include "RTjpeg.h"

int fd;
int ostr;
int8_t *strm;
long fsize;
long ftot=0;
long stot=0;
long dropped=0;
int lf=0, tf=0;
int M,Q;
RTjpeg_t *rtj;
uint8_t *planes[3];
int w=384, h=288;

void writeit(unsigned char *buf)
{
 int tmp;

// ioctl(fd, BTTV_FIELDNR, &tf);
 tf+=2; // fixme! *&^&* v4l

 planes[0] = buf;
 planes[1] = planes[0] + w*h;
 planes[2] = planes[1] + (w*h)/4;
 tmp=RTjpeg_compress(rtj, strm, planes);
 write(ostr, strm, tmp);
 
 ftot+=fsize;
 stot+=tmp;
 
 if(tf!=(lf+2))dropped++;
 lf=tf;
 
 fprintf(stderr, "dropped %ld %u ratio %f     \r", dropped, tf,  (float)ftot/(float)stot);
}

int main(int argc, char** argv)
{
  struct video_mmap mm;
  struct video_mbuf vm;
  unsigned char *buf;
  int frame;
  int i, j;

  if(argc!=3)
  {
   fprintf(stderr, "Usage: test3 <Q factor> <motion threshold>\n\n");
   exit(-1);
  }

  Q=atoi(argv[1]);
  M=atoi(argv[2]);
  
  fd = open("/dev/video0", O_RDWR|O_CREAT);
  if(fd<=0){
    perror("open");
    exit(-1);
  }
    
  if(ioctl(fd, VIDIOCGMBUF, &vm)<0)
  {
  	perror("VIDIOCMCAPTUREi0");
  	exit(-1);
  }
  if(vm.frames<2)
  {
  	fprintf(stderr, "stoopid prog want min 2 cap buffs!\n");
  	exit(-1);
  }
  fprintf(stderr, "%d:%d\n", vm.frames, vm.size);
    
  buf = (unsigned char*)mmap(0, vm.size, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0);
  if (buf==(unsigned char *)-1)
  {
   perror("mmap");
   exit(-1);
  }	
  
  ostr=open("ostr",O_RDWR|O_CREAT);

  fsize=(w*h)+((w*h)>>1);
  
  strm=malloc(w*h*2);
  rtj = RTjpeg_init();
  RTjpeg_set_size(rtj, &w, &h);
  RTjpeg_set_quality(rtj, &Q);
  i = RTJ_YUV420;
  RTjpeg_set_format(rtj, &i);
  i = 25;
  j = M/2;
  RTjpeg_set_intra(rtj, &i, &M, &j);

  mm.frame  = 0;
  mm.height = h;
  mm.width  = w;
  mm.format = VIDEO_PALETTE_YUV420P    ; /* YCrCb422 */
  if(ioctl(fd, VIDIOCMCAPTURE, &mm)<0) perror("VIDIOCMCAPTUREi0");
  mm.frame  = 1;
  if(ioctl(fd, VIDIOCMCAPTURE, &mm)<0) perror("VIDIOCMCAPTUREi1");
  while(1)
  {
   frame=0;
   mm.frame  = 0;
   if(ioctl(fd, VIDIOCSYNC, &frame)<0) perror("VIDIOCSYNC0");
    else
    {
     if(ioctl(fd, VIDIOCMCAPTURE, &mm)<0) perror("VIDIOCMCAPTURE0");
     writeit(buf+vm.offsets[0]);
    }
   frame=1;
   mm.frame  = 1;
   if(ioctl(fd, VIDIOCSYNC, &frame)<0) perror("VIDIOCSYNC1");
    else
    {
     if(ioctl(fd, VIDIOCMCAPTURE, &mm)<0) perror("VIDIOCMCAPTURE1");
     writeit(buf+vm.offsets[1]);
    }
  }
 return 0;
}
