#include <stdlib.h>
#include <stdio.h>
#include "RTjpeg.h"
#include "XJ.h"
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>

RTjpeg_t *rtj;

void hup(int foo)
{
 XJ_exit();
 exit(0);
}

void (*vidconv)(RTjpeg_t *rtj, uint8_t **planes, uint8_t **rows);

int main(void)
{
 int f;
 unsigned char *buf;
 char *sbuf;
 int8_t *strm;
 long tf=0;
 int i;
 unsigned char tmpf[10];
 int w, h;
 uint8_t *planes[3];
 uint8_t **rows;
 
 signal(SIGINT, &hup);
 
 f=open("ostr", O_RDONLY);
 read(f, tmpf, 10);
 w = RTjpeg_frame_width(tmpf);
 h = RTjpeg_frame_height(tmpf);
 fprintf(stderr, "%dx%d\n", w, h);
 lseek(f, 0, SEEK_SET);
 rtj = RTjpeg_init();
 i = RTJ_YUV420;
 RTjpeg_set_format(rtj, &i);
 
 strm=malloc(w*h+(w*h)/2+8);
 sbuf=XJ_init(w, h, "t3", "t3");
 rows = malloc(sizeof(uint8_t*)*h);
 for(i=0; i<h; i++)
  rows[i] = sbuf+w*(XJ_depth/8)*i;
 switch (XJ_depth)
 {
  case 8: vidconv=RTjpeg_yuv420rgb8;
          break;
  case 16: vidconv=RTjpeg_yuv420rgb16;
           break;
  case 24: vidconv=RTjpeg_yuv420bgr24;
           // break;
  case 32: vidconv=RTjpeg_yuv420bgr32; break;
           break;
  default: fprintf(stderr, "Unsupported display depth\n");
           exit(-1);
           break;
 }
 
 buf=malloc(w*h+(w*h)/2);
 planes[0] = buf;
 planes[1] = planes[0] + w*h;
 planes[2] = planes[1] + (w*h)/4;

 while(read(f, strm, 4)==4)
 {
  if(read(f, strm+4, RTjpeg_frame_framesize(strm)-4)!=(RTjpeg_frame_framesize(strm)-4))
  {
   XJ_exit();
   fprintf(stderr, "total frames %ld\n", tf);
   exit(0);
  }
//  fprintf(stderr, "%d:%d:%d:%d:%d ", RTjpeg_frame_size(strm), RTjpeg_frame_width(strm), RTjpeg_frame_height(strm), RTjpeg_frame_quality(strm), RTjpeg_frame_key(strm));
  RTjpeg_decompress(rtj, strm, planes);
  vidconv(rtj, planes, rows);
  XJ_show();
  usleep(50000);
  tf++;
 }
 
 fprintf(stderr, "total frames %ld\n", tf);
 XJ_exit();

 return 0;
}
