/***************************************************************************
                          RTjpegCodec.h  -  description
                             -------------------
    begin                : Sun Nov 25 2001
    copyright            : (C) 2001 by Christian Tusche
    email                : ctusche@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RTJPEGCODEC_H
#define RTJPEGCODEC_H

#include "VideoFile/VideoFile.h"
#include "RTJpeg/RTjpeg.h"

/**Lesen und schreiben von RTjpeg codierten Videoframes
  *@author Christian Tusche
  */

class RTjpegCodec : public V_Codec  {
public: 
    RTjpegCodec( V_Track *Track );
    ~RTjpegCodec();

    /**Farbraum festlegen
      */
    bool ColorModel( int cmodel );

    // Bild kopieren
    int CopyFrame( void );

protected:
    /**Video-Bild schreiben
      */
    int encode( VideoFrame *bild );

    /**Video-Bild lesen
      */
    int decode( VideoFrame *bild );

    // Optionen setzen
    int SetOption( OptionEntry *opt );

private:
    /**Jpeg-Qualitt
      */
    bool jpegQuality( int q );

    uint8_t *data_buf;
    long data_buf_bytes;
    long data_bytes;
    RTjpeg_t *compress_struct;
    RTjpeg_t *decompress_struct;
    int letztes_bild;

    // Optionen
    int quality;
    int key_interval;
    int motion_level;
};

#endif
