#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "RTjpegCodec.h"


static PluginList<Codec_Info> *Info;


V_Codec *create_codec( V_Track *track )
{
    return new RTjpegCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;
    
    String Text = _("decode and encode RTJPEG");

    //                        DateiTyp    Codecalias  Konstruktor    Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info( "Avi",       "RT-JPEG",  &create_codec, "RTJ0",    Text );
    *Info += new Codec_Info( "Quicktime", "RT-JPEG",  &create_codec, "RTJ0",    Text );
    
    return "V_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
