/****************************************************************************************/
/***** Xvid basierter DivX/MPEG4 - Videocodec *******************************************/
/****************************************************************************************/

#ifndef _XVIDCODEC_H_
#define _XVIDCODEC_H_

#define LINUX
//#include "decore/src/decore.h"
//#include "decore50/decore.h"
//extern "C" {
//#include "encore2/src/encoder.h"
//}
//#include "encore.h"

#include "xvidcore/src/xvid.h"

#include "VideoFile/VideoFile.h"

class XvidCodec:public V_Codec {
public:
    XvidCodec( V_Track *Track );

    ~XvidCodec();

    // Farbraum festlegen
    bool ColorModel( int cmodel );

    // positionieren
    int SeekFrame( long bild );

    // Bild kopieren
    int CopyFrame( void );

private:
    void init_decode( void );
    void init_encode( void );

    bool decode_setup, encode_setup;

    unsigned char *puffer;
    unsigned char *null_puffer;
    int null_puffer_gr;

    XVID_DEC_PARAM dec_param;
    XVID_ENC_PARAM enc_param;
    void *decode_handle;
    void *encode_handle;
    float rate;
    int render;
    int colorspace;

    // Optionen
    int postproces;     // Ausgabefilter
    int general_opt;    // Encoderoptionen
    int motion_opt;     // Motion-Compensation

protected:
    // Video-Bild schreiben
    int encode( VideoFrame *bild );

    // Video-Bild lesen
    int decode( VideoFrame *bild );

    // Optionen setzen
    int SetOption( OptionEntry *opt );
};


#endif
