#include <unistd.h>

#include "VideoFile/PluginList.h"
#include "VideoFile/Codec_Info.h"
#include "VideoFile/translate.h"

#include "XvidCodec.h"


static PluginList<Codec_Info> *Info;


V_Codec *create_codec( V_Track *track )
{
    return new XvidCodec( track );
}


extern "C" {

const char *plugin_init( void )
{
    Info = new PluginList<Codec_Info>;
    
    //String Text = _("decode OpenDivX video");
    //                        DateiTyp    Codecalias  Konstruktor    Codecname  Beschreibung lesen  schreiben
    //*Info += new Codec_Info( "Avi",       "DIVX",     &create_codec, "divx",    Text,        true,  false );
    //*Info += new Codec_Info( "Avi",       "divx",     &create_codec, "divx",    Text,        true,  false );

    String Text = _("decode and encode XviD video");
    //                        DateiTyp    Codecalias  Konstruktor    Codecname  Beschreibung lesen  schreiben
    *Info += new Codec_Info( "Avi",       "XVID",     &create_codec, "XVID",    Text,        true,  true );
    *Info += new Codec_Info( "Quicktime", "XVID",     &create_codec, "DIVX",    Text,        true,  true );
    
    return "V_Codec";
}




void *plugin_info( void )
{
    return Info;
}




void plugin_delete( void )
{
    delete Info;
}


}
